//#include <sys/timeb.h> //time metrics

#include <stdio.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#define GTK_NO_CHECK_CASTS
#define G_DISABLE_CAST_CHECKS
#define NDEBUG

#define FIVE_CHARS(x1,x2,x3,x4,x5)   (((((((((x5)<<8)|(x4))<<8)|(x3))<<8)|(x2))<<8)|(x1))
#define WINDOW FIVE_CHARS('-','w','i','n','d')
#define FRAME FIVE_CHARS('-','f','r','a','m')
#define VBOX FIVE_CHARS('-','v','b','o','x')
#define HBOX FIVE_CHARS('-','h','b','o','x')
#define BOXCLOS FIVE_CHARS('-','c','l','o','s')
#define HSEPARATOR FIVE_CHARS('-','h','s','e','p')
#define VSEPARATOR FIVE_CHARS('-','v','s','e','p')
#define LABEL FIVE_CHARS('-','l','a','b','e')
#define BUTTON FIVE_CHARS('-','b','u','t','t')
#define CHECKBOX FIVE_CHARS('-','c','h','e','c')
#define TEXT FIVE_CHARS('-','t','e','x','t')
#define HSCALE FIVE_CHARS('-','h','s','c','a')
#define VSCALE FIVE_CHARS('-','v','s','c','a')

void on_button_clicked(GtkButton *button, char *user_data){printf("action=\"%s\"\n",user_data);}
void on_checkbutton_toggled(GtkToggleButton *togglebutton, char *user_data){
	if (GTK_TOGGLE_BUTTON(togglebutton)->active){printf("%s=\"on\"\n",user_data);
	}else{printf("%s=\"off\"\n",user_data);}
}

int main(int argc, char *argv[]){
GtkWidget *widgets[99];
unsigned char widget=0, i=1, containers=0, packer=0, packers[9];
int j;

//struct timeb tmb; ftime(&tmb); printf("%ld.%d\n", tmb.time, tmb.millitm);//time metrics

gtk_set_locale ();
gtk_init (&argc, &argv);

while (i<argc){ /* loop through args to make widgets - buttons with actions */
j=FIVE_CHARS(argv[i][0],argv[i][1],argv[i][2],argv[i][3],argv[i][4]);

switch ( j ) { /* initialize widgets based on -tag */
case	WINDOW	:	
	i++;
	widgets[widget] = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data(GTK_OBJECT(widgets[widget]), argv[i], widgets[widget]);
	gtk_window_set_title(GTK_WINDOW(widgets[widget]), argv[i]);
break;

case	BOXCLOS	:	widget--;break;

case	VBOX	:
	widgets[widget] = gtk_vbox_new (FALSE, 0);
break;

case	HBOX	:
	widgets[widget] = gtk_hbox_new (FALSE, 0);
break;

case	HSEPARATOR	:
	widgets[widget] = gtk_hseparator_new ();
break;

case	VSEPARATOR	:
	widgets[widget] = gtk_vseparator_new ();
break;
	
case	LABEL	:	
	i++;
	widgets[widget] = gtk_label_new (argv[i]);
break;

case	BUTTON	:
	i++;
	widgets[widget] = gtk_button_new_with_label(argv[i]);
	i++;
	gtk_signal_connect(GTK_OBJECT (widgets[widget]), "clicked", GTK_SIGNAL_FUNC(on_button_clicked),argv[i]);
break;

case	CHECKBOX	:
	i++;
	widgets[widget] = gtk_check_button_new_with_label (argv[i]);
	i++;
	gtk_signal_connect (GTK_OBJECT (widgets[widget]), "toggled", GTK_SIGNAL_FUNC (on_checkbutton_toggled), argv[i]);
break;

case	TEXT	:
	widgets[widget] = gtk_text_new (NULL, NULL);
	i++;
	gtk_text_insert (GTK_TEXT (widgets[widget]), NULL, NULL, NULL, argv[i], -1);
	//gtk_signal_connect (GTK_OBJECT (widgets[widget]), "changed", GTK_SIGNAL_FUNC (on_text_changed), NULL);
break;

case	HSCALE	:
	widgets[widget] = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 100, 1, 0, 0)));
	//gtk_signal_connect (GTK_OBJECT (widgets[widget]), "drag_end", GTK_SIGNAL_FUNC (on_scale_drag_end), NULL);
break;

case	VSCALE	:
	widgets[widget] = gtk_vscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 100, 1, 0, 0)));
	//gtk_signal_connect (GTK_OBJECT (widgets[widget]), "drag_end", GTK_SIGNAL_FUNC (on_scale_drag_end), NULL);
break;

default   :
	printf(	"usage:\n%s -window title -{v,h}box [-button label action] [-checkbox label var]\n"
			"	Last argument processed was %s \n",argv[0],argv[i]);
	goto END;
break;
} /* end initializing widgets from -tag */

/* begin stuff that all widgets need to do */

/* end stuff that all widgets need to do */

switch ( j ) { /* begin packing */
case	WINDOW	:	
case	BOXCLOS	:	break;

default   :
	gtk_widget_show (widgets[widget]);
	gtk_widget_ref (widgets[widget]);
	gtk_object_set_data_full (GTK_OBJECT (widgets[0]), argv[i], widgets[widget], (GtkDestroyNotify) gtk_widget_unref);
	if (containers > 0){
		gtk_container_add(GTK_CONTAINER (widgets[0]), widgets[widget]);
		containers--;
	}else{
		gtk_box_pack_start(GTK_BOX(widgets[packers[packer]]), widgets[widget], TRUE, TRUE, 0);
	}
break;
} /* end packing */


switch	( j )	{ /* PUSH/POP packers */
case	BOXCLOS	:	packer--; break; //pop the packer and decrement widget, because this is the only non-widget
case	FRAME	:	
case	WINDOW	:	containers++;break;
case	VBOX	:	
case	HBOX	:	packer++;
					packers[packer] = widget;
default			:	break;
} /* PUSH/POP packers */

i++;widget++;  /* for argv[] and widgets[] */
} /* end arg loop */
gtk_widget_show (widgets[0]);
gtk_signal_connect(GTK_OBJECT (widgets[0]), "destroy", GTK_SIGNAL_FUNC (gtk_main_quit),NULL);

//ftime(&tmb); printf("%ld.%d\n", tmb.time, tmb.millitm);//time metrics --currently about 45 msec

gtk_main();
END:
return 0;
}